package org.choub.minecraft.launcher;

import java.text.MessageFormat;

import org.apache.log4j.Logger;
import org.choub.minecraft.launcher.impl.ILauncherImpl;
import org.choub.minecraft.launcher.task.LauncherStartupTask;


public class Launcher {

	private static Logger logger = Logger.getLogger(Launcher.class);

	private LauncherContext context;
	private ILauncherImpl implementation;

	public Launcher(ILauncherImpl implementation) {
		this.implementation = implementation;
	}

	public void start() {
		context = new LauncherContext(implementation.getConfiguration());
		context.getTaskManager().run(new LauncherStartupTask());
	}

	public void stop() {
		context.getTaskManager().cancelAllTasks();
	}

	public void shutdown(int exitCode) {
		logger.info(MessageFormat.format("Launcher SHUTDOWN requested with exit code [{0}]...", exitCode));
		System.exit(exitCode);
	}
}
