package org.choub.minecraft.launcher.constant;

public enum OS {
	UNKNOWN("/unknown/"),
	WINDOWS("/win/i"),
	MACINTOSH("/mac/i"),
	LINUX("/(linux)|(unix)/i");

	private String matchName;

	private OS(String matchName) {
		this.matchName = matchName;
	}

	public static OS fromOSName(String osName) {
		String name = System.getProperty("os.name").toLowerCase();
		for (OS os : OS.values()) {
			if (name.matches(os.matchName)) {
				return os;
			}
		}
		return UNKNOWN;
	}
}
