package org.choub.minecraft.launcher.task;

import java.text.MessageFormat;

import org.apache.log4j.Logger;
import org.choub.minecraft.launcher.LauncherContext;


public abstract class BackgroundTask extends Thread {

	private static Logger logger = Logger.getLogger(BackgroundTask.class);
	private LauncherContext context;

	@Override
	public void run() {
		if (isInterrupted()) {
			// thread has been canceled by the task manager.
			logger.info(MessageFormat.format("# Task Cancelled: [{0}]", this.toString()));
			return;
		}
		try {
			executeTask();
		} catch (Exception e) {
			logger.error("Unexpected Background Task Error", e);
		}
	}

	public void setContext(LauncherContext context) {
		this.context = context;
	}

	public LauncherContext getContext() {
		return this.context;
	}

	public abstract void executeTask();
}
