package org.choub.minecraft.launcher.util;

import java.io.File;
import java.text.MessageFormat;


public class FileUtil {

	private static final String MACINTOSH_HOME = "/Library/Application Support/";

	public static File getHomeDirectory() {
		String homePath = System.getProperty("user.home", ".");

		File home;
		switch (SystemUtil.getOS()) {
			case MACINTOSH:
				home = new File(homePath, MACINTOSH_HOME);
				break;
			case WINDOWS:
				String appData = System.getenv("APPDATA");
				home = new File(appData != null ? appData : homePath);
				break;
			case LINUX:
			default:
				home = new File(homePath);
				break;
		}
		if (!home.exists()) {
			throw new RuntimeException("Unable to get home directory !");
		}
		return home;
	}

	public static File getWorkingDirectory(String directory) {
		File file = new File(getHomeDirectory(), "." + directory + "/");
		if (!file.exists() && !file.mkdirs()) {
			throw new RuntimeException(MessageFormat.format("Unable to create working directory [{0}]!", file.getAbsolutePath()));
		}
		return file;
	}
}
